<?php
/**
 *
 * Auther: heyu
 * DateTime: 2019-12-24 13:56
 *
 */

namespace kwy\aliPayOpenApi\lib;


use kwy\util\http\CurlHttp;

class ApiRequest
{
    /** @var CurlHttp $http */
    private $http;

    /**
     * @return CurlHttp
     */
    public function getHttp(): CurlHttp
    {
        return $this->http;
    }

    /**
     * @param CurlHttp $http
     */
    public function setHttp(CurlHttp $http)
    {
        $this->http = $http;
    }
    /** @var Config $config */
    private $config;

    /**
     * @return Config
     */
    public function getConfig(): Config
    {
        return $this->config;
    }

    /**
     * @param Config $config
     */
    public function setConfig(Config $config)
    {
        $this->config = $config;
    }
    protected function call($method,$data){
        if (empty($this->http)){
            $this->http = new CurlHttp();
        }
        $url=Config::GATE_WAY.'?charset=utf-8';

        $this->http->setUrl($url);
        $params=[
            'app_id'=>$this->config->app_id,
            'method'=>$method,
            'charset'=>'utf-8',
            'sign_type'=>'RSA2',
            'timestamp'=>date('Y-m-d H:i:s'),
            'version'=>'1.0',
            'biz_content'=>json_encode($data),
        ];
        $params['sign']=$this->getSign($params);
        $this->http->setResponseType('array');
        return $this->http->post($params);
    }

    private function getSign($params){
        $str='';
        ksort($params);
        foreach ($params as $k=>$v){
            $str.=$k.'='.$v.'&';
        }
        $str = rtrim($str,'&');
        if (!empty($this->config->private_key_path)){
            $priKey = file_get_contents($this->config->private_key_path);
        }else{
            $priKey = empty($this->config->private_key_content)?false:$this->config->private_key_content;
        }

        if ($priKey===false){
            throw new \Exception('证书文件路径错误或者传入的证书格式错误');
        }
        $proKeyRes = openssl_get_privatekey($priKey);
        $sign='';
        openssl_sign($str, $sign, $proKeyRes, OPENSSL_ALGO_SHA256);
        openssl_free_key($proKeyRes);
        return base64_encode($sign);
    }

}